#!/usr/local/bin/perl -w
# dfountain.p simulates the emission of packets by a digital fountain.
#
# The first version decodes greedily on the fly. Tue 15/4/03  #(All histogram results before now are over by 1 packet)
# The second version reads in a fixed number then attempt to decode.
# The third version allows you to tweak tau and for example remove tau's spike.
#
# The program appears to have a memory leak. Sun 26 4 2003. Have not found it.
# Actually pehaps not. It is using 20% of yell's memory regardless, but somehow it
# was grinding to a halt and swapping.

$removetauspike  = 0 ; 
$removetail = 0 ; # remove all rho's tail
#
#  dfountain.p K=10000 c=0.1 delta=0.5 T=1000
#  dfountain.p K=10 c=0.1 delta=0.5 T=1 N=20
#
# see itp/dfountain for data file produced by this
#
# and see there octave DEMO for plotting of it.
#
# nice +19 dfountain.p K=10000 c=0.1 delta=0.5 T=1000 N=20000 verbose=-1
# nice +19 dfountain.p K=10000 c=0.1 delta=0.5 T=1 N=20000 boundary=1000 dat=packetcount2
# nice +19 dfountain.p K=10000 c=0.1 delta=0.5 T=1000 N=20000  verbose=-1 boundary=1000 dat=packetcount2
# nice +19 dfountain.p K=10000 c=0.1 delta=0.5 T=1000 N=20000  verbose=-1 boundary=10 dat=packetcount
# nice +19 dfountain.p K=10000 c=0.03 delta=0.5 T=1000 N=20000  verbose=-1 boundary=1000 dat=c0.03d0.5K10000
# nice +19 dfountain.p K=10000 c=0.03 delta=0.5 T=1000 N=20000  verbose=-1 boundary=1000 dat=c0.03d0.5K10000b
# dfountain.p  writetargetdegreedistbn=1 c=0.03 delta=0.5 

# nice +19 dfountain.p K=10000 c=0.01 delta=0.1 T=2000 N=20000  verbose=-1 boundary=1000 dat=c0.01d0.1K10000  Z=1.014
# nice +19 dfountain.p K=10000 c=0.01 delta=0.5 T=2000 N=20000  verbose=-1 boundary=1000 dat=c0.01d0.5K10000b Z=1.010
# nice +19 dfountain.p K=10000 c=0.01 delta=0.5 T=2000 N=20000  verbose=-1 boundary=1000 dat=c0.01d0.5K10000b Z=1.010 
# nice +19 dfountain.p K=10000 Kprime=10750 c=0.03 delta=0.5 T=1 N=20000  verbose=0 boundary=1000 dat=tmp recorddegrees=1
# nice +19 dfountain.p K=10000 Kprime=10750 c=0.1 delta=0.5 T=1 N=20000  verbose=0 boundary=1000 dat=tmp recorddegrees=1 degreehist=degreehistorybad
# result: boundary=1000 is much faster
#
# see also 
# domino.p is a domino decoder for a code,
#   or an equation-solving planning engine

$K=10000; $c=0.1 ;$delta=0.5; $T = 1; # number of trials
$Kprime = 10750 ; # do not attempt to decode until this many received.
                  # set this to zero to revert to version 1 behaviour
$N=20000; # max number packets permitted.

$boundary=1000 ; # boundary between two methods of generating random packet

$writetargetdegreedistbn = 0 ;
$targetdist = "targetdist" ;
$dat="packetcount" ;

$recorddegrees = 0 ; # writes massive record of decoding history
$octave=1; # the style of writing.
$degreehist = "degreehistory" ;

# domino.p in=initialcondnfile < Afile
#
# in qecc/GF17, simple examples
#
#  domino.p in=constraints < A2
#  domino.p in=constraints2 < A2

$verbose = 0 ;

eval "\$$1=\$2" while @ARGV && $ARGV[0]=~ /^(\w+)=(.*)/ && shift;

if ($boundary > ($K)*0.5 ) {
    $boundary = 0.5*$K ; 
}
# create distribution
$R = $c*sqrt($K) * log($K/$delta) ;
$dspecial = int( ($K/$R)+0.5 ) ;
for ( $d = 1 ; $d <= $K ; $d ++ ) {
    if ( $removetail ) {
	$rho[$d] = ($d> ($K/$R)+0.5) ? 0.0 : ($d==1)? 1.0 / $K :  1.0/($d*($d-1)) ;
    }	else {
	$rho[$d] = ($d==1)? 1.0 / $K :  1.0/($d*($d-1)) ;
    }
    if($removetauspike ) {
	$tau[$d] = ($d> ($K/$R)-0.5) ? 0.0: $R/($d*$K) ;
    } else {
	$tau[$d] = ($d> ($K/$R)+0.5) ? 0.0:  ( ($d>(($K/$R) -0.5))  ? $R * log($R/$delta)/$K : $R/($d*$K) );
    }
    $Zr += $rho[$d] ;
    $Zt += $tau[$d] ;
}
$Z = $Zr+$Zt ; 
printf "K=$K ; R=$R ; dspecial=$dspecial ; Zr=$Zr ; Zt=$Zt  ; Z=$Z \n" ;
$cum[0]=0.0;
for ( $d = 1 ; $d <= $K ; $d ++ ) {
    $rho[$d] = ($rho[$d]+$tau[$d]) / $Z ;
    $cum[$d] = $cum[$d-1] + $rho[$d] ;
}
if($writetargetdegreedistbn) { 
    open(TDD,">$targetdist"); 
    for ( $d = 1 ; $d <= $K ; $d ++ ) {
	if ($tau[$d]>0) {
	    printf TDD "%d %10.5g %10.5g %10.5g %10.5g \n" ,
	    $d,	$rho[$d] , $tau[$d]/$Z , 	$cum[$d] , 1.0- $cum[$d] ;
	}	    else {
	    printf TDD "%d %10.5g %s %10.5g %10.5g \n" ,
	    $d,	$rho[$d] , "NA" , 	$cum[$d] , 1.0- $cum[$d] 
	    ;
	}
	if ($d==350) {printf " set arrow 123 from %d,0 to %d,%10.5g\n",$d+1,$d+1,1.0- $cum[$d]  ;  }
    }
    close(TDD) ;
    exit(0);
}
$success = 0 ; $fails = 0 ; $NTOT = 0 ; 
if($recorddegrees) {
    open ( DE , ">$degreehist" ) ;
    $maxkprint =     $dspecial +10 ; if ($maxkprint > $K ) { $maxkprint = $K ; }
    
    if($octave) {
	$maxkprintp = $maxkprint + 1 ; # (for the zero column...)
	print DE "# name: a\n# type: matrix\n# rows: $K\n# columns: $maxkprintp\n" ;  
    }

}
for ($t=1;$t<=$T;$t++) {
    # test, fresh start
    $numknown = 0 ; 
    for ( $k = 1 ; $k <= $K ; $k ++ ) {
	$known[$k] = 0 ;
	$klist[$k] = " " ; # list of dudes to whom k is connected
	$numwithdegree[$k] = 0 ;
    }
    $numwithdegree[0] = 0 ;
    $numdegree1 = 0 ; # keep track of the "n" dudes with degree 1
    $degree1list = " " ; 
    for ( $n=1;($n<=$N) && ($numknown<$K) ;$n++ ) {
	# send a new packet
	makepacket($n) ;
	if ($verbose>0) {
	    printf "%4d/%5d - New node $n: d $truedegree[$n], rd $degree[$n], -> $nlist[$n]\n" , $numknown,$K ;
	} elsif($verbose>-1) {
	    printf "%4d/%5d - $n: d %4d rd %4d " , $numknown,$K ,$truedegree[$n], $degree[$n];
# 	    printf " $numdegree1=$numwithdegree[1] $numwithdegree[2]  $numwithdegree[3] " if($debug) ;
	} elsif (!($n%500)) { print STDERR "$n." ; }

	if ( $n >= $Kprime ) { # then we are permitted to decode
	    # polish off whomever we can
	    while( $numdegree1 > 0 ) {
		if($recorddegrees) {
		    dorecorddegrees();
		}
		( ( $degree1list =~ s/\s(\d+)\s/ / ) && (    $nnn = $1  ) ) || print STDERR "MAJOR ERROR\n" ; 
		determine($nnn) ;
	    }
	}
	if($numknown<$K){ print STDERR "stuck, new packet please\n" if ($verbose>0) ; }
	if(($verbose<1)&&($verbose>-1)) { print "\n" ; }
    }
    $n-- ;
    open ( D, ">> $dat" ) ;
    if ($numknown == $K ) {
	print "SUCCESS, done in $n packets\n" ;
	$success ++ ;
	$NTOT += $n ;
	# print $n to a data file for histogramming later.
	print D "$n\n" ;
    } else {
	print "FAILURE $n\n" ;
	$fails ++ ; 
	print D "# $n\n" ;
    }
    close (D) ;
    if($recorddegrees) {
	if($octave) {
	    print STDERR "octave-2.0\n load -force $degreehist\n" ; 
	} else {
	    print DE "\n\n" ;
	}
    }
    
}
print "In $success successes, $NTOT packets transmitted\n" ;
$mean = $NTOT / $success ;
printf "Mean = %12.7g\n" , $mean ;

sub dorecorddegrees {
    print DE "$n" ;
    for ( $k = 1 ; ($k <= $maxkprint)  ; $k ++ ) {
	print DE " $numwithdegree[$k]" ;
    }
    print DE "\n" ;
}

# last in first out
sub determine {
    local($n) = @_ ;
    $numdegree1 -- ;
    $k_to_remove = $nlist[$n] ;
    print STDERR "  removing (thanks to $n) k =$k_to_remove\n" if ($verbose>0) ;
    $_ = $k_to_remove ;     @ks = split ;
    if(($#ks>0)||($#ks<0)) { print STDERR "error ($_), this should be 0 :- $#ks\n" ;}
    $numknown ++ ;
    $k = $ks[0] ;
    $known[$k] = 1;
    $_  = $klist[$k] ; # ns_to_decrement
    @ns = split ;
    foreach $nn ( @ns ) {
	if ( $nn eq $n ) { # skip this, except for bookkeeping
	    $numwithdegree[$degree[$nn]] -- ;
	} else {
	    $copy = $nlist[$nn] ;
	    $matches= ( $nlist[$nn] =~ s/\s$k\s/ / ) ;
	    if ($matches != 1 ) { print STDERR "ERROR 1234978\n" ; }
	    print  "    found $matches match for k=$k in $nn list, $copy, which is now replaced by $nlist[$nn] \n" if($verbose>0) ;
	    if($degree[$nn] == 1 ) { # then we lost one of our star ripple people. need to remove them
		showripple() if($verbose>0);
		$matches= ( $degree1list =~ s/\s$nn\s/ / ) ;
		if ($matches != 1 ) { print STDERR "ERROR 139 \n" ; }
		else {
		    $numdegree1 -- ;
		    if ($verbose>0)  {
			print  "    we just lost $nn who had degree 1. \n" ;
		    } else {
			print "-" if ($verbose>-1) ;
		    }
		}
		showripple()  if($verbose>0);
	    }
	    $numwithdegree[$degree[$nn]] -- ;
	    $degree[$nn] -- ;
	    $numwithdegree[$degree[$nn]] ++ ;
	    if($degree[$nn] == 1 ) {
		# a new ripple has arisen
		$numdegree1 ++ ;
		$degree1list .= "$nn " ;
		print "+" if ($verbose>-1)  ;
	    }
	}
    }
    if ($verbose>0) {
	showripple();
    }
}

sub showripple {
    print "  The Ripple is " ;
    print " $degree1list" ;
    print ". (Known: $numknown/$K)\n" ;
}



sub makepacket {
    local($n) = @_ ;
    
    # pick a degree
    $u = rand() ;
DLOOP:    for ( $d = 1 ; $d <= $K ; $d ++ ) {
	if ( $u < $cum[$d] ) { last DLOOP ; }
    }
    if ($d>$K) { print STDERR "error\n" ; }

    # Two methods, depending on how big $d is
    
    # now pick those edges
    $truedegree[$n] = $d ;
    $degree[$n] = 0 ;
    $nlist[$n] = " " ; # list of dudes to whom n is connected

    if ( $d > $boundary ) { # run through all K, deciding whether to include
	$left = $K ; # 
	for ( $k = 1 ; ($d>0)&&($k <= $K) ; $k ++ ) {
	    if ( rand() < ($d/$left) ) {
		$d -- ;
		addkton() ;
	    }
	    $left -- ;
	}
    } else { # generate them directly.
	$taken = " " ; 
	for ( ; $d > 0 ; $d -- ) {
	    do { $k = int ( rand($K) ) + 1 ; }
	    while ( $taken =~ m/\s$k\s/ ) ;
	    $taken .= "$k " ;
	    addkton() ;
	}
    }
    $numwithdegree[$degree[$n]] ++ ;
    if ( $degree[$n] == 1 ) {
	$numdegree1 ++ ;
	$degree1list .= "$n " ;
	print "+" if ($verbose>-1)  ;
    }
}

sub		addkton {
    if ( !$known[$k] ) {
	$degree[$n] ++ ;
	$nlist[$n] .= "$k " ;
	$klist[$k] .= "$n " ;
    }
}






